#include <math.h>

class kmean
{
	public:
		kmean(int ID,double X, double Y, double Z,unsigned int N);
		~kmean();
		//kmean self(void);
		int move(double X, double Y, double Z);//moves the mean to the point(X,Y,Z)
		int calculate_distances(gsl_matrix *MatrixIN, int N, gsl_matrix *distances);//calculates the distances of the "N" items with their positions defined in "MatrixIN" and writes these values to the "distances" matrix
		char * whereis(void);//returns the position of the mean in a formatted string
		double XX(void)	{return x;}//returns the x-component of the mean's position
		double YY(void)	{return y;}//returns the y-component of the mean's position
		double ZZ(void)	{return z;}//returns the z-component of the mean's position
		int II(void) {return id;}//returns the mean's id
		int NN(void) {return n;}//returns the number of items in the world (as the mean knows it)
		int RR(void);//prints out the responsibility list (used for debugging purposes actually)
		gsl_vector * RRV(void) {return r;}//returns the responsibility list
		int set_r(int index, bool included);//sets the "index"th element of the responsibility list as the bool "included". (ie, registers the "index". item as whether it belongs or not belongs to the mean)
		int moveCoM(gsl_matrix *MatrixIN);//moves the mean to the center of mass of the items it is responsible for
		int RTOT(void) {return r_tott;}//returns the total number of items the mean is responsible for
		
	private:
		unsigned int id,n;//"id" is for the unique identifier and "n" is the total number of items in the world.
		double x,y,z;//coordinates of the mean
		gsl_vector * r;//responsibility list of the mean
		char buffer [150];//some dummy variable to use in the "whereis" method
		unsigned int r_tott;//total number of data points this mean is responsible for
};
int check_distances(gsl_matrix* distances, int numberOfWorldElements, kmean **means);//checks the "distances" matrix elements for the means in the "means" array and registers each item in the responsibility list of the nearest mean.
double distance(double a1, double a2,double a3,double b1,double b2,double b3);//distance criteria is defined with this function
